package com.abi.qms.platform.dao.mapper;

import com.abi.qms.platform.dao.vo.result.ListBrandCodeReportVO;
import com.abi.qms.platform.dao.vo.result.ListFactoryCodeReportVO;
import com.abi.qms.platform.dao.vo.result.ListPackageCodeVo;
import com.abi.qms.platform.dao.vo.result.ListMaterialCodeReportVO;
import com.abi.qms.platform.dto.req.ReportReq;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;

/**
 * @author ludashi
 * @date 2021年06月02日 15:40
 */
public interface ReportServiceMapper  {
    
    /**
     * (603版 品牌使用码量占比列表 已废弃)
     * @author ludashi
     * @date 2021/6/2 17:50
     * @param reportReq
     * @return java.util.List<com.abi.qms.platform.dao.vo.result.ListBrandCodeReportVO>
     */
    //List<ListBrandCodeReportVO> queryBrandCodeProportion(@Param("reportReq") ReportReq reportReq);

    /**
     * 查询生成码数量
     * @param reportReq
     * @return
     */
    List<ListPackageCodeVo> queryPackageCodeNum(@Param("reportReq") ReportReq reportReq);

    /**
     * 往期生成码数量
     * @param beginDate
     * @param endDate
     * @return
     */
    ListPackageCodeVo queryPackageCodeNumPast(@Param("beginDate")LocalDateTime beginDate,@Param("endDate")LocalDateTime endDate);
    /**
     * 查询下载码数量
     * @param reportReq
     * @return
     */
    List<ListPackageCodeVo> queryLoadPackageCodeNum(@Param("reportReq") ReportReq reportReq);

    /**
     * 往期下载码数量
     * @param beginDate
     * @param endDate
     * @return
     */
    ListPackageCodeVo queryLoadPackageCodeNumPast(@Param("beginDate")LocalDateTime beginDate,@Param("endDate")LocalDateTime endDate);

    /**
     * 查询激活码数量
     * @param reportReq
     * @return
     */
    List<ListPackageCodeVo> queryActivateCodeNum(@Param("reportReq") ReportReq reportReq);

    /**
     * 往期激活码数量
     * @param beginDate
     * @param endDate
     * @return
     */
    ListPackageCodeVo queryActivateCodeNumPast(@Param("beginDate")LocalDateTime beginDate,@Param("endDate")LocalDateTime endDate);

    /**
     * 物料使用码量排名
     * @param reportReq
     * @return
     */
    List<ListMaterialCodeReportVO> queryMaterialCodeRanking(@Param("reportReq") ReportReq reportReq);

    /**
     * 包材厂使用码量，下载率
     * @param reportReq
     * @return
     */
    List<ListFactoryCodeReportVO> queryFactoryCodeTotal(@Param("reportReq") ReportReq reportReq, @Param("isDownload") Integer isDownload);
}
